<?php
namespace moonlight\eticket;
class eticket_audit_mysql {
	public function __call($name, $arguments){
		$v_tmp_arr = explode("_", $name);
		$v_call_obj = $v_tmp_arr[0];
		if(isset($this->co_db_root)){
			return call_user_func_array(array($this->co_db_root, $name), $arguments);
		}
	}
	public function __construct( &$p_co_db ){
		$this->co_db_root = $p_co_db;
	}
	/**
	*Audit Data By Condition
	*
	* @access public
	* @param array $p_str_wc.
	* @return
	*/
	public function audit_show_report_data_by_conditons($p_str_wc){
		$v_query="SELECT * FROM ".$this->get_db_table_prefix()."audit";
		$v_result=$this->co_db_root->execute_query($v_query);
		return $v_result;
	}	
	/**
	*Get Agency Data 
	*
	* @access public
	* @return
	*/
	public function audit_get_agency_data(){
		$v_query="SELECT ";
		$v_query.="ag_id AS agency_id, ";
		$v_query.="ag_code AS agency_code, ";
		$v_query.="ag_name AS agency_name ";
		$v_query.="FROM  ".$this->get_db_table_prefix()."agency ";
		$v_query.="WHERE  _rec_deleted_on IS NULL";
		$v_result=$this->co_db_root->execute_query($v_query);	
		return $v_result;
	}
	/**
	*Get User Data 
	*
	* @access public
	* @return
	*/
	public function audit_get_user_data(){
		$v_col_name = "location";
		$v_location_condition = \E::get('obj_curr_module')->get_location_condition($v_col_name);
		$v_col_name = "agency";
		$v_agency_condition = \E::get('obj_curr_module')->get_agency_condition($v_col_name);
		$v_query="SELECT ";
		$v_query.="usr_id AS user_id, ";
		$v_query.="usr_short_name AS user_name, ";
		$v_query.="role AS user_role ";
		$v_query.="FROM  ".$this->get_db_table_prefix()."user ";
		$v_query.="WHERE  _rec_deleted_on IS NULL"." ".$v_agency_condition;
		$v_query.= $v_location_condition;
		$v_result=$this->co_db_root->execute_query($v_query);	
		return $v_result;
	}
	/**
	*Get Function Data 
	*
	* @access public
	* @return
	*/
	public function audti_get_function_data(){
		$v_query="";
		$v_result=$this->co_db_root->execute_query($v_query);	
		return $v_result;
	}
	/**
	 * Retrieve listing with filters
	 *
	 * @access public
	 * @return
	 */
	public function audit_list_with_no_post($p_cond=NULL, $p_sort_by=NULL, $p_order_by=NULL, $p_page_start=NULL, $p_page_length=NULL){
		$v_col_name = "agency_name";
		$v_agency_condition = \E::get('obj_curr_module')->get_agency_condition($v_col_name);
		$v_col_name = "location_id";
		$v_location_condition = \E::get('obj_curr_module')->get_location_condition($v_col_name);
		$v_date_range = $p_cond['date_range']; 
		$v_date_search = "";
		if( $v_date_range != '' ) {
			$v_date_range = explode("to",$v_date_range);
			$v_start_date = "";
			$v_end_date = "";
			if( count($v_date_range) == 2 ) {
				$v_start_date = $v_date_range[0];
				$v_end_date = $v_date_range[1];
			} else {
				$v_start_date = $v_date_range[0];
				$v_end_date = $v_date_range[0];
			}
			$v_date_search = " AND ( date_time >= '".date("Y-m-d 00:00:00",strtotime( \U::safe_sql_string($v_start_date)))."' AND date_time <= '".date("Y-m-d 23:59:59",strtotime(\U::safe_sql_string($v_end_date)))."' ) ";
		}
 		$v_user_filter = $p_cond['user_filter'];
		$v_user_filter_search = "";
		if( $v_user_filter != '' ) {
			$v_user_filter_search = " AND ( user_id IN('" . implode ( "', '", \U::safe_sql_string($v_user_filter)) . "') ) ";
		}
		$v_agency_filter_text = $p_cond['agency_filter'];
		$v_agency_filter = "";
		if( $v_agency_filter_text != '' ) {
			$v_agency_filter_text_implode = "'" . implode ( "', '", \U::safe_sql_string($v_agency_filter_text)) . "'";
			$v_agency_filter = " AND ( agency_name IN(".$v_agency_filter_text_implode.") ) ";
		}
		$v_function_filter = $p_cond['function_filter'];
		$v_function_filter_search = "";
		if( $v_function_filter != '' ) {
			$v_function_filter_implode = "'" . implode ( "', '", \U::safe_sql_string($v_function_filter)) . "'";
			$v_function_filter_search = " AND ( module_name IN(".$v_function_filter_implode.") ) ";
		}
		$v_limitation_data = "";
		if( $p_page_start != '' && $p_page_length != '' ) {
			$v_limitation_data = " LIMIT " . \U::safe_sql_string($p_page_start) . ", " . \U::safe_sql_string($p_page_length) . "";
		}
		$v_order_by = "";
		if( $p_order_by != '' && $p_sort_by != '' ) {
			$v_order_by = " ORDER BY " . \U::safe_sql_string($p_order_by) . " " . \U::safe_sql_string($p_sort_by) . " ";
		}
		$v_query = "
				SELECT
					*
				FROM
					" . $this->get_db_table_prefix() . "audit 
				WHERE 
				 	audit_id != ''
				 	".$v_date_search." 
				 	".$v_agency_condition." 
				 	".$v_location_condition." 
				 	".$v_user_filter_search." 
				 	".$v_agency_filter." 
				 	".$v_function_filter_search." 
				 	".$v_order_by."
				 	".$v_limitation_data."
				";
		return $this->co_db_root->execute_query($v_query);
	}
}
?>