<?php
namespace moonlight\eticket;
class eticket_report_ticket_mysql {
	private $co_db_root;
	public function __call($name, $arguments){
		$v_tmp_arr = explode("_", $name);
		$v_call_obj = $v_tmp_arr[0];
		if(isset($this->co_db_root)){
			return call_user_func_array(array($this->co_db_root, $name), $arguments);
		}
	}
	public function __construct( &$p_co_db ){
		$this->co_db_root = $p_co_db;
	}
	/**
	 * Ticket Listing
	 *
	 * @access public
	 * @return
	 */
	public function report_ticket_get_report_listing($p_cond=NULL, $p_sort_by=NULL, $p_order_by=NULL, $p_page_start=NULL, $p_page_length=NULL){
		$v_col_name_l = "location_id";
		$v_location_condition = \E::get('obj_curr_module')->get_location_condition($v_col_name_l);
		$v_location_condition_loc_admin = "";
		if( \E::get_session("location_administrator") == 1 ) {
			$v_location_condition_loc_admin = " AND ( location_id = '".\E::get_session( "c_user_location_id")."' OR _rec_created_by = '".\E::get_session('usr_id')."') ";
		}
		$v_col_name = "agency_id";
		$v_agency_condition = \E::get('obj_curr_module')->get_agency_condition($v_col_name);
		$v_location_name_code = $p_cond['report_id']; 
		$v_status_condition = " (_rec_status IN('SHOW','DELETED'))  ";
		if( isset($p_cond['report_status']) && $p_cond['report_status'] != '' ) {
			if( $p_cond['report_status'] == 21 ) {
				$v_status_condition = " (_rec_status IN('SHOW','DELETED'))  ";
			} else if( $p_cond['report_status'] == 22 ) {
				$v_status_condition = " (_rec_status IN('SHOW'))  ";
			} else if( $p_cond['report_status'] == 23 ) {
				$v_status_condition = " (_rec_status IN('DELETED'))  ";
			}
		}
		$v_report_type_cond = "";
		if( isset($v_location_name_code) ) {
			if( $v_location_name_code != '' ) {
				if( $v_location_name_code == 1 ) {
					$v_report_type_cond = "";
				} else if( $v_location_name_code == 2 ) {
					$v_user_id = \E::get_session('usr_id');
					$v_report_type_cond = " AND _rec_created_by = '".\U::safe_sql_string($v_user_id)."' ";
				} else if( $v_location_name_code == 3 ) {
					$v_report_type_cond = " AND payment_method = '1' ";
				}
				$v_limitation_data = "";
				if( $p_page_start != '' && $p_page_length != '' ) {
					$v_limitation_data = " LIMIT " . \U::safe_sql_string($p_page_start) . ", " . \U::safe_sql_string($p_page_length) . "";
				}
				$v_order_by = "";
				if( $p_order_by != '' && $p_sort_by != '' ) {
					$v_order_by = " ORDER BY " . \U::safe_sql_string($p_order_by) . " " . \U::safe_sql_string($p_sort_by) . " ";
		 		}
				$v_query = "
						SELECT
							st.*,
							(
								SELECT
									GROUP_CONCAT(reference_number SEPARATOR ',')
								FROM 
									" . $this->get_db_table_prefix() . "tickets
								WHERE 
									" . $this->get_db_table_prefix() . "tickets.sales_transaction_id = st.id
								AND
									transaction_date >= '".date("Y-m-d 00:00:00")."'
								AND 
									transaction_date <= '".date("Y-m-d 23:59:59")."' 
							) as ticket_reference_number_lists,
							(
								SELECT
									GROUP_CONCAT(id SEPARATOR ',')
								FROM 
									" . $this->get_db_table_prefix() . "tickets
								WHERE 
									" . $this->get_db_table_prefix() . "tickets.sales_transaction_id = st.id
								AND
									transaction_date >= '".date("Y-m-d 00:00:00")."'
								AND 
									transaction_date <= '".date("Y-m-d 23:59:59")."' 
								AND
									_rec_status = \"SHOW\"
							) as ticket_id_lists,
							(
								SELECT
									COUNT(*) as totalcashtransaction
								FROM 
									" . $this->get_db_table_prefix() . "sales_transaction
								WHERE 
									".$v_status_condition."
									".$v_report_type_cond."
									".$v_agency_condition."
								 	".$v_location_condition_loc_admin."
								AND
									payment_method = 1
								AND
									transaction_date >= '".date("Y-m-d 00:00:00")."'
								AND 
									transaction_date <= '".date("Y-m-d 23:59:59")."' 
								AND
									_rec_status = \"SHOW\"
							) as totalcashtransaction,
							(
								SELECT
									COUNT(*) as totalsarawakpaytransaction
								FROM 
									" . $this->get_db_table_prefix() . "sales_transaction
								WHERE 
									".$v_status_condition."
									".$v_report_type_cond."
									".$v_agency_condition."
								 	".$v_location_condition_loc_admin."
								AND
									payment_method IN(2,3)
								AND
									transaction_date >= '".date("Y-m-d 00:00:00")."'
								AND 
									transaction_date <= '".date("Y-m-d 23:59:59")."' 
								AND
									_rec_status = \"SHOW\"
							) as totalsarawakpaytransaction,
							(
								SELECT
									SUM(final_amount) as totalcash
								FROM 
									" . $this->get_db_table_prefix() . "sales_transaction
								WHERE 
									".$v_status_condition."
									".$v_report_type_cond."
									".$v_agency_condition."
								 	".$v_location_condition_loc_admin."
								AND
									transaction_date >= '".date("Y-m-d 00:00:00")."'
								AND 
									transaction_date <= '".date("Y-m-d 23:59:59")."' 
								AND
									_rec_status = \"SHOW\"
							) as totalcash,
							(
								SELECT
									SUM(final_amount) as totalcash_only
								FROM 
									" . $this->get_db_table_prefix() . "sales_transaction
								WHERE 
									".$v_status_condition."
									".$v_report_type_cond."
									".$v_agency_condition."
								 	".$v_location_condition_loc_admin."
								AND
									payment_method = 1
								AND
									transaction_date >= '".date("Y-m-d 00:00:00")."'
								AND 
									transaction_date <= '".date("Y-m-d 23:59:59")."' 
								AND
									_rec_status = \"SHOW\"
							) as totalcash_only,
							(
								SELECT
									SUM(final_amount) as totalcash_sarawak
								FROM 
									" . $this->get_db_table_prefix() . "sales_transaction
								WHERE 
									".$v_status_condition."
									".$v_report_type_cond."
									".$v_agency_condition."
								 	".$v_location_condition_loc_admin."
								AND
									payment_method IN(2,3)
								AND
									transaction_date >= '".date("Y-m-d 00:00:00")."'
								AND 
									transaction_date <= '".date("Y-m-d 23:59:59")."' 
								AND
									_rec_status = \"SHOW\"
							) as totalcash_sarawak
						FROM
							" . $this->get_db_table_prefix() . "sales_transaction st
						WHERE 
						 	".$v_status_condition."
						 	".$v_agency_condition."
							".$v_location_condition_loc_admin."
						 	".$v_report_type_cond."
						AND
							transaction_date >= '".date("Y-m-d 00:00:00")."'
						AND 
							transaction_date <= '".date("Y-m-d 23:59:59")."' 
						 	".$v_order_by."
						 	".$v_limitation_data."
						";

				return $this->co_db_root->execute_query($v_query);
			}
		}
	}
	/**
	 * Ticket Listing Filteration Records
	 *
	 * @access public
	 * @return
	 */
	public function report_ticket_get_reprint_ticket_listing($p_cond=NULL, $p_sort_by=NULL, $p_order_by=NULL, $p_page_start=NULL, $p_page_length=NULL){
		$v_col_name_l = "location_id";
		$v_location_condition = \E::get('obj_curr_module')->get_location_condition($v_col_name_l);
		
		$v_location_condition_loc_admin = "";
		if( \E::get_session("location_administrator") == 1 ) {
			$v_location_condition_loc_admin = " AND ( location_id = '".\E::get_session( "c_user_location_id")."' OR _rec_created_by = '".\E::get_session('usr_id')."') ";
		}

		$v_col_name = "agency_id";
		$v_agency_condition = \E::get('obj_curr_module')->get_agency_condition($v_col_name);
		if(isset($p_cond['date_range'])){
			$v_date_range = $p_cond['date_range']; 
		} else {
			$v_date_range = '';
		}
		$v_date_search = "";
		if( $v_date_range != '' ) {
			$v_date_range = explode("to",$v_date_range);
			$v_start_date = "";
			$v_end_date = "";
			if( count($v_date_range) == 2 ) {
				$v_start_date = $v_date_range[0];
				$v_end_date = $v_date_range[1];
			} else {
				$v_start_date = $v_date_range[0];
				$v_end_date = $v_date_range[0];
			}
			$v_date_search = " AND ( date_time >= '".date("Y-m-d 00:00:00",strtotime( \U::safe_sql_string($v_start_date)))."' AND date_time <= '".date("Y-m-d 23:59:59",strtotime(\U::safe_sql_string($v_end_date)))."' ) ";
		}
		$v_location_filter = $p_cond['location_filter'];
		$v_location_filter_search = "";
		if( $v_location_filter != '' ) {
			$v_location_filter_text_implode = "'" . implode ( "', '", \U::safe_sql_string($v_location_filter)) . "'";
			$v_location_filter_search = " AND ( location_id IN(".$v_location_filter_text_implode.") ) ";
		}
 		$v_user_filter = $p_cond['user_id_filter'];
		$v_user_filter_search = "";
		if( $v_user_filter != '' ) {
			$v_user_filter_text_implode = "'" . implode ( "', '", \U::safe_sql_string($v_user_filter)) . "'";
			$v_user_filter_search = " AND ( _rec_created_by IN(".$v_user_filter_text_implode.") ) ";
		}
		$v_payment_mode_filter_text = $p_cond['payment_method_filter'];
		$v_poayment_mode_filter = "";
		if( $v_payment_mode_filter_text != '' ) {
			$v_payment_mode_filter_text_implode = "'" . implode ( "', '", \U::safe_sql_string($v_payment_mode_filter_text)) . "'";
			$v_poayment_mode_filter = " AND ( payment_method IN(".$v_payment_mode_filter_text_implode.") ) ";
		}
		$v_date_range = $p_cond['date_range_dates']; 
		$v_date_search = "";
		if( $v_date_range != '' ) {
			$v_date_range = explode("to",$v_date_range);
			$v_start_date = "";
			$v_end_date = "";
			if( count($v_date_range) == 2 ) {
				$v_start_date = $v_date_range[0];
				$v_end_date = $v_date_range[1];
			} else {
				$v_start_date = $v_date_range[0];
				$v_end_date = $v_date_range[0];
			}
			$v_date_search = " AND ( transaction_date >= '".date("Y-m-d 00:00:00",strtotime( \U::safe_sql_string($v_start_date)))."' AND transaction_date <= '".date("Y-m-d 23:59:59",strtotime(\U::safe_sql_string($v_end_date)))."' ) ";
		}
		$v_limitation_data = "";
		if( $p_page_start != '' && $p_page_length != '' ) {
			$v_limitation_data = " LIMIT " . \U::safe_sql_string($p_page_start) . ", " . \U::safe_sql_string($p_page_length) . "";
		}
		$v_order_by = "";
		if( $p_order_by != '' && $p_sort_by != '' ) {
			$v_order_by = " ORDER BY " . \U::safe_sql_string($p_order_by) . " " . \U::safe_sql_string($p_sort_by) . " ";
		}
		$v_status_condition = " (_rec_status IN('SHOW','DELETED'))  ";
		if( isset($p_cond['report_status']) && $p_cond['report_status'] != '' ) {
			if( $p_cond['report_status'] == 21 ) {
				$v_status_condition = " (_rec_status IN('SHOW','DELETED'))  ";
			} else if( $p_cond['report_status'] == 22 ) {
				$v_status_condition = " (_rec_status IN('SHOW'))  ";
			} else if( $p_cond['report_status'] == 23 ) {
				$v_status_condition = " (_rec_status IN('DELETED'))  ";
			}
		}
		$v_query = "
				SELECT
					st.*,
					(
						SELECT
							COUNT(*) as totalcashtransaction
						FROM 
							" . $this->get_db_table_prefix() . "sales_transaction
						WHERE 
							".$v_status_condition." 
							".$v_agency_condition."
						 	".$v_location_condition_loc_admin."
						 	".$v_location_filter_search."
						 	".$v_date_search." 
						 	".$v_poayment_mode_filter." 
		 					".$v_user_filter_search."
						AND
							payment_method = 1
						AND
							_rec_status = \"SHOW\"
					) as totalcashtransaction,
					(
						SELECT
							COUNT(*) as totalsarawakpaytransaction
						FROM 
							" . $this->get_db_table_prefix() . "sales_transaction
						WHERE 
							".$v_status_condition." 
							".$v_agency_condition."
						 	".$v_location_condition_loc_admin."
						 	".$v_location_filter_search."
						 	".$v_date_search." 
						 	".$v_poayment_mode_filter." 
		 					".$v_user_filter_search."
						AND
							payment_method IN(2,3)
						AND
							_rec_status = \"SHOW\"
					) as totalsarawakpaytransaction,
					(
						SELECT
							SUM(final_amount) as totalcash
						FROM 
							" . $this->get_db_table_prefix() . "sales_transaction
						WHERE 
							".$v_status_condition." 
							".$v_agency_condition."
						 	".$v_location_condition_loc_admin."
						 	".$v_location_filter_search."
						 	".$v_date_search." 
						 	".$v_poayment_mode_filter." 
		 					".$v_user_filter_search."
		 				AND
							_rec_status = \"SHOW\"
					) as totalcash,
					(
						SELECT
							SUM(final_amount) as totalcash_only
						FROM 
							" . $this->get_db_table_prefix() . "sales_transaction
						WHERE 
							".$v_status_condition." 
							".$v_agency_condition."
						 	".$v_location_condition_loc_admin."
						 	".$v_location_filter_search."
						 	".$v_date_search." 
						 	".$v_poayment_mode_filter." 
		 					".$v_user_filter_search."
						AND
							payment_method = 1
						AND
							_rec_status = \"SHOW\"
					) as totalcash_only,
					(
						SELECT
							SUM(final_amount) as totalcash_sarawak
						FROM 
							" . $this->get_db_table_prefix() . "sales_transaction
						WHERE 
							".$v_status_condition." 
							".$v_agency_condition."
						 	".$v_location_condition_loc_admin."
						 	".$v_location_filter_search."
						 	".$v_date_search." 
						 	".$v_poayment_mode_filter." 
		 					".$v_user_filter_search."
						AND
							payment_method IN(2,3)
						AND
							_rec_status = \"SHOW\"
					) as totalcash_sarawak
				FROM
					" . $this->get_db_table_prefix() . "sales_transaction st
				WHERE 
				 	".$v_status_condition."
				 	".$v_agency_condition." 
				 	".$v_location_condition_loc_admin." 
					".$v_location_filter_search."
				 	".$v_date_search." 
				 	".$v_poayment_mode_filter." 
				 	".$v_user_filter_search."
				 	".$v_order_by."
				 	".$v_limitation_data."
				";
		return $this->co_db_root->execute_query($v_query);
	}
	/**
	 * Ticket Reports Listing Data with Filteration
	 *
	 * @access public
	 * @return
	 */
	public function report_ticket_get_locations_categories($p_ticket_id_list) {
		if($p_ticket_id_list  ){
			if( $p_ticket_id_list != '' ) {
				$v_query = "SELECT
								" . $this->get_db_table_prefix() . "ticket_demographic_info.ticket_category,
								" . $this->get_db_table_prefix() . "ticket_demographic_info.location,
								" . $this->get_db_table_prefix() . "locations.code as location_code,
								" . $this->get_db_table_prefix() . "ticket_category.name as category_name
					 		FROM 
					 			" . $this->get_db_table_prefix() . "ticket_demographic_info
					 		INNER JOIN
								".$this->get_db_table_prefix()."locations
							ON
								".$this->get_db_table_prefix()."ticket_demographic_info.location = ".$this->get_db_table_prefix()."locations.id 
							INNER JOIN
								".$this->get_db_table_prefix()."ticket_category
							ON
								".$this->get_db_table_prefix()."ticket_demographic_info.ticket_category = ".$this->get_db_table_prefix()."ticket_category.id 
					 		WHERE 
					 			ticket_id IN(".$p_ticket_id_list.")
					 ";
				$v_locations_data = $this->co_db_root->execute_query($v_query);	
				return $v_locations_data;
			}
		}
	}
	/**
	 * Get Ticket and Dempgraphic Data Only Based on Transaction id
	 *
	 * @access public
	 * @return
	 */
	public function report_ticket_get_tickets_and_demographic_data($p_transaction_id) {
		if( $p_transaction_id && $p_transaction_id != '' ){
			$v_query = "SELECT
							*
				 		FROM 
				 			" . $this->get_db_table_prefix() . "tickets 
				 		INNER JOIN
							".$this->get_db_table_prefix()."ticket_demographic_info
						ON
							".$this->get_db_table_prefix()."ticket_demographic_info.ticket_id = ".$this->get_db_table_prefix()."tickets.id 
				 		WHERE 
				 			" . $this->get_db_table_prefix() . "tickets.sales_transaction_id = '".$p_transaction_id."'
				 ";
			$v_tickets_and_demographic = $this->co_db_root->execute_query($v_query);	
			return $v_tickets_and_demographic;
		}
	}
	/**
	 * Ticket Reports get Locations + Categories + Profile Data
	 *
	 * @access public
	 * @return
	 */
	public function report_ticket_get_locations_categories_profile($p_ticket_profile_id,$p_ticket_category,$p_location) {
		if( ((isset($p_ticket_profile_id)) && ($p_ticket_profile_id != '')) && ((isset($p_ticket_category)) && ($p_ticket_category != '')) && ((isset($p_location)) && ($p_location != '')) ) {
			$v_query = "SELECT
							" . $this->get_db_table_prefix() . "ticket_profile.name as profile_name,
				 			(
								SELECT
									" . $this->get_db_table_prefix() . "ticket_category.name
								FROM 
									" . $this->get_db_table_prefix() . "ticket_category
								WHERE 
									" . $this->get_db_table_prefix() . "ticket_category.id = ".$p_ticket_category."
							) as ticket_category,
							(
								SELECT
									" . $this->get_db_table_prefix() . "locations.name
								FROM 
									" . $this->get_db_table_prefix() . "locations
								WHERE 
									" . $this->get_db_table_prefix() . "locations.id = ".$p_location."
							) as ticket_location
						FROM 
							" . $this->get_db_table_prefix() . "ticket_profile
				 		WHERE 
				 			" . $this->get_db_table_prefix() . "ticket_profile.id = ".$p_ticket_profile_id."
				 ";
			$v_locations_data = $this->co_db_root->execute_query($v_query);	
			return $v_locations_data;
		}
	}
	/**
	 * Get Code table Value By Key Name
	 *
	 * @access public
	 * @return
	 */
	public function report_ticket_get_code_table_values_by_key_name($p_key_name=NULL) {
		if( $p_key_name != '' ) {
			$v_query = "SELECT
							*
				 		FROM 
				 			" . $this->get_db_table_prefix() . "code_table 
				 		WHERE
				 			key_name = '".\U::safe_sql_string($p_key_name)."'
				 		AND 
				 			_rec_status = \"SHOW\" 
				 ";
			$v_code_table_data = $this->co_db_root->execute_query($v_query);	
			if( isset($v_code_table_data) ) {
				return $v_code_table_data;
			}
		}
	}
}
?>