<?php
namespace moonlight\eticket;
class eticket_user_group_mysql {
	private $co_db_root;
	public function __call($name, $arguments){
		$v_tmp_arr = explode("_", $name);
		$v_call_obj = $v_tmp_arr[0];
		if(isset($this->co_db_root)){
			return call_user_func_array(array($this->co_db_root, $name), $arguments);
		}
	}
	public function __construct( &$p_co_db ){
		$this->co_db_root = $p_co_db;
	}
	/**
	 * Retrieve user group bygroup id
	 *
	 * @access public
	 * @return
	 */
	public function user_group_get( $p_id ){
		// QUERY - acl group table
		$v_query = 	"SELECT 
						*
					FROM " . $this->get_db_table_prefix() . "acl_group 
					WHERE _rec_status = \"SHOW\" 
					AND group_id=\"" . \U::safe_sql_string( $p_id ) . "\"
					";
		$v_result = $this->co_db_root->execute_query($v_query);
		if($v_result && is_array($v_result)){
			foreach($v_result as $v_key=>$v_value){
				$v_result[$v_key]['_rec_modified_on'] = $this->co_db_root->__to_display_date($v_result[$v_key]['_rec_modified_on']);
			}
		}
		// QUERY - label table
		$v_query = 	"SELECT 
						kwd_lang,
						kwd_value
					FROM " . $this->get_db_table_prefix() . "acl_group_lbl l
					LEFT JOIN " . $this->get_db_table_prefix() . "acl_group g
					ON g.group_id = l.kwd_code
					WHERE g._rec_status = \"SHOW\" 
					AND g.group_id=\"" . \U::safe_sql_string( $p_id ) . "\"
					";
		$v_result_lbl = $this->co_db_root->execute_query($v_query);
		if($v_result_lbl && is_array($v_result_lbl)){
			foreach($v_result_lbl as $v_value){
				$v_result[0]['kwd_value'][$v_value['kwd_lang']] = $v_value['kwd_value'];
			}
		}
		return $v_result;
	}
	/**
	 * Function to retrieve the list of group
	 *
	 * @access public
	 * @return
	 */
	public function user_group_list( $p_order=NULL, $p_start = NULL, $p_num_of_rec = NULL ){
		// Default Language
		$v_lang_info = \E::get('obj_curr_module')->get_lang();
		
		// ORDER BY - Coding
		$v_order_by = '';
		if($p_order !== NULL){
			foreach($p_order as $v_value){
				if($v_order_by == '') $v_order_by = ' ORDER BY '.\U::safe_sql_string( $v_value['order_by'] ).' '.\U::safe_sql_string( $v_value['sort_by'] );
				else $v_order_by .= ', ' . \U::safe_sql_string( $v_value['order_by'] ) . ' ' .\U::safe_sql_string( $v_value['sort_by'] );
			}
		}
		// LIMIT - Coding
		$v_limit = '';
		if($p_start !== NULL && $p_num_of_rec !== NULL){
			$v_limit = ' LIMIT ' . \U::safe_sql_string($p_start) . ', ' . \U::safe_sql_string($p_num_of_rec);
		}
		// QUERY - Coding
		$v_query = 	"SELECT 
						l.kwd_code as group_id,
						l.kwd_value as group_name,
						g._rec_modified_on
					FROM " . $this->get_db_table_prefix() . "acl_group_lbl l
					LEFT JOIN ". $this->get_db_table_prefix() . "acl_group g
					ON g.group_id=l.kwd_code
					WHERE g._rec_status = \"SHOW\" AND l.kwd_lang=\"".$v_lang_info."\"
					" . $v_order_by . $v_limit;	
					
		$v_result = $this->co_db_root->execute_query($v_query);
		if($v_result && is_array($v_result)){
			foreach($v_result as $v_key=>$v_value){
				$v_result[$v_key]['_rec_modified_on'] = $this->co_db_root->__to_display_date($v_result[$v_key]['_rec_modified_on']);
			}
		}
		return $v_result;
	}
	/**
	 * Function to retrieve the list of agency based on user group
	 *
	 * @access public
	 * @return
	 */
	public function user_group_agency_lit(){
		$v_col_name = "ag_id";
		$v_agency_condition = \E::get('obj_curr_module')->get_agency_condition($v_col_name);
		$v_query = 	"SELECT * 
					FROM " . $this->get_db_table_prefix() . "agency
					WHERE
						_rec_status = \"SHOW\" 	
						".$v_agency_condition."
					";
		$v_result = $this->co_db_root->execute_query($v_query);
		return $v_result;
	}
	/**
	 * Function to retrieve the list of agency based on user specific agency id
	 *
	 * @access public
	 * @return
	 */
	public function user_group_get_agency($p_agency_id){
		$v_query = 	"SELECT
						* 
						FROM " . $this->get_db_table_prefix() . "agency
					WHERE
						ag_id = '".$p_agency_id."'
					";
		$v_result = $this->co_db_root->execute_query($v_query);
		return $v_result;
	}
	/**
	 * Function to retrieve ticket profile listing
	 *
	 * @access public
	 * @return
	 */
	public function user_group_ticket_list(){
		$v_col_name = "agency";
		$v_agency_condition = \E::get('obj_curr_module')->get_agency_condition($v_col_name);
		$v_col_name = "location";
		$v_location_condition = \E::get('obj_curr_module')->get_location_condition($v_col_name);
		$v_query = 	"SELECT
						* 
					FROM
						" . $this->get_db_table_prefix() . "ticket_profile
					WHERE
						_rec_status = \"SHOW\" 	
						".$v_agency_condition."
						".$v_location_condition."
					";			
		$v_result = $this->co_db_root->execute_query($v_query);
		return $v_result;
	}
	/**
	 * Function to retrieve ticket category listing
	 *
	 * @access public
	 * @return
	 */
	public function user_group_categories_list(){
		$v_col_name = "agency";
		$v_agency_condition = \E::get('obj_curr_module')->get_agency_condition($v_col_name);
		$v_query = 	"SELECT
						* 
					FROM
						" . $this->get_db_table_prefix() . "ticket_category
					WHERE
						_rec_status = \"SHOW\" 	
						".$v_agency_condition."
					";			
		$v_result = $this->co_db_root->execute_query($v_query);
		return $v_result;
	}
	/**
	 * Function to retrieve location listing
	 *
	 * @access public
	 * @return
	 */
	public function user_group_location_list(){
		$v_login_type = \E::get_session('logged_in_user_type');
		$v_login_agency_id_condition = "";
		if( isset($v_login_type) && $v_login_type != 2 ) {
			$v_login_agency = \E::get_session('c_user_agency_id');
			$v_login_agency_id_condition = " AND agency_id = '".$v_login_agency."' ";
		}
		$v_col_name = "id";
		$v_location_condition = \E::get('obj_curr_module')->get_location_condition($v_col_name);
		$v_query = 	"SELECT
						* 
					FROM
						" . $this->get_db_table_prefix() . "locations
					WHERE
						_rec_status = \"SHOW\" 	
						".$v_login_agency_id_condition."
						".$v_location_condition."
					";			
		$v_result = $this->co_db_root->execute_query($v_query);
		return $v_result;
	}
	/**
	 * Get Locations According to Logged in user Agency and Location
	 *
	 * @access public
	 * @return
	 */
	public function user_group_location_against_location_agency(){
		$v_login_type = \E::get_session('logged_in_user_type');
		$v_login_agency_id_condition = "";
		if( isset($v_login_type) && $v_login_type != 2 ) {
			$v_login_agency = \E::get_session('c_user_agency_id');
			$v_login_agency_id_condition = " AND agency_id = '".$v_login_agency."' ";
			$v_col_name = "id";
			$v_location_condition = \E::get('obj_curr_module')->get_location_condition($v_col_name,"buy_ticket");
		}
		$v_query = 	"SELECT
						* 
					FROM
						" . $this->get_db_table_prefix() . "locations
					WHERE
						_rec_status = \"SHOW\" 	
						".$v_login_agency_id_condition."
						".$v_location_condition."
					";			
		$v_result = $this->co_db_root->execute_query($v_query);
		return $v_result;
	}
	/**
	 * Function to count the total of group
	 *
	 * @access public
	 * @return
	 */
	public function user_group_list_total(){
		// Default Language
		$v_lang_info = \E::get('obj_curr_module')->get_lang();
		// QUERY - Coding
		$v_query = 	"SELECT 
						COUNT(kwd_code) AS 'total_rec'
					FROM " . $this->get_db_table_prefix() . "acl_group_lbl l
					LEFT JOIN " . $this->get_db_table_prefix() . "acl_group g
					ON g.group_id = l.kwd_code
					WHERE g._rec_status = \"SHOW\"
					AND l.kwd_lang=\"".$v_lang_info."\" ";					
		$v_result = $this->co_db_root->execute_query($v_query);
		return $v_result[0]['total_rec'];
	}
	/**
	 * Function to add user group
	 *
	 * @access public
	 * @return
	 */
	public function user_group_add( $p_value ){
		$v_fields_list='';
		$v_value_list='';
		for($v_c=0; $v_c<$p_value['comp_count']; $v_c++){
			$v_fields_list .= 'group_com_' . \U::safe_sql_string( $p_value['acl'][$v_c]['name'] ) . ', ';
			$v_value_list .= '"' . \U::safe_sql_string( $p_value['acl'][$v_c]['value'] ) . '", ';
		}
		$v_query = 	"INSERT INTO 
						" . $this->get_db_table_prefix() . "acl_group(
						" . $v_fields_list . "
						_rec_created_on,
						_rec_created_by,
						_rec_modified_on,
						_rec_modified_by,
						_rec_status
					)VALUE(
						" . $v_value_list . "
						\"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
						\"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
						\"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
						\"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
						\"" . \U::safe_sql_string( $p_value['_rec_status'] ) . "\"
					)";
		$v_result = $this->co_db_root->execute_query($v_query);
		
		return $this->co_db_root->get_last_insert_id();
	}
	/**
	 * Function to add user group label
	 *
	 * @access public
	 * @return
	 */
	public function user_group_lbl_add( $p_value ){
		$v_rec_value="(
					\"" . \U::safe_sql_string( $p_value['id'] ) . "\",
					\"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
					\"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
					\"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
					\"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
					";
		$v_rec_value_list = "";
		$v_lang_info = \E::get('obj_curr_module')->get_supported_lang();
		foreach($v_lang_info as $v_lang){
			if($v_rec_value_list!=""){
				$v_rec_value_list .= ",";
			}
			$v_rec_value_list .= $v_rec_value;
			$v_rec_value_list .= "\"" . \U::safe_sql_string( $v_lang ) . "\",";
			$v_rec_value_list .= "\"" . \U::safe_sql_string( $p_value['group_name'][$v_lang] ) . "\"";
			$v_rec_value_list .= ")";
		}
		$v_query = 	"INSERT INTO 
					" . $this->get_db_table_prefix() . "acl_group_lbl(
						kwd_code,
						_rec_created_on,
						_rec_created_by,
						_rec_modified_on,
						_rec_modified_by,
						kwd_lang,
						kwd_value
					)VALUE{$v_rec_value_list}";
		$v_result = $this->co_db_root->execute_query($v_query);
	}
	/**
	 * Function to add user group logs data
	 *
	 * @access public
	 * @return
	 */
	public function user_group_add_logs_data( $p_log_data, $p_action,$p_module_name, $p_old_data ){
		
		$full_name = \E::get_session( 'usr_id' );
		$v_cond['usr_id'] = $full_name;
		$v_check_info = \E::get('obj_system_module')->user_get($v_cond);
		$v_query = 	"INSERT INTO 
						" . $this->get_db_table_prefix() . "audit
					SET
						module_name = '".\U::safe_sql_string($p_module_name)."',
						user_name = '".\U::safe_sql_string($v_check_info['usr_full_name'])."',
						agency_name = '".\U::safe_sql_string( \E::get_session( 'c_user_agency_id' ) )."',
						location_id = '".\U::safe_sql_string( \E::get_session( 'c_user_location_id' ) )."',
						date_time = '".date("Y-m-d H:i:s")."',
						audit_action = '".$p_action."',
						user_id = '".\U::safe_sql_string( \E::get_session( 'usr_id' ) )."',
						new_data = '".\U::safe_sql_string(json_encode($p_log_data))."',
						old_data = '".\U::safe_sql_string(json_encode($p_old_data))."',
						_rec_created_on = \"" . \U::safe_sql_string( date("Y-m-d H:i:s") ) . "\",
						_rec_created_by = \"" . \U::safe_sql_string( \E::get_session( 'usr_id' ) ) . "\",
						_rec_modified_on = \"" . \U::safe_sql_string( date("Y-m-d H:i:s") ) . "\",
						_rec_modified_by = \"" . \U::safe_sql_string( \E::get_session( 'usr_id' ) ) . "\"
					";
		$v_result = $this->co_db_root->execute_query($v_query);
	}
	/**
	 * Function to add user roles
	 *
	 * @access public
	 * @return
	 */
	public function user_group_user_roles( $p_role_id, $p_user_id ){
		
		$v_query = 	"INSERT INTO 
						" . $this->get_db_table_prefix() . "user_role_assignment
					SET
						user_id = '".\U::safe_sql_string( $p_user_id )."',
						user_roles_id = '".\U::safe_sql_string( $p_role_id )."',
						_rec_status = \"" . \U::safe_sql_string( "SHOW" ) . "\",
						_rec_created_on = \"" . \U::safe_sql_string( date("Y-m-d H:i:s") ) . "\",
						_rec_created_by = \"" . \U::safe_sql_string( \E::get_session( 'usr_id' ) ) . "\",
						_rec_modified_on = \"" . \U::safe_sql_string( date("Y-m-d H:i:s") ) . "\",
						_rec_modified_by = \"" . \U::safe_sql_string( \E::get_session( 'usr_id' ) ) . "\"
					";
		$v_result = $this->co_db_root->execute_query($v_query);
	}
	/**
	 * Function to update user roles
	 *
	 * @access public
	 * @return
	 */
	public function user_group_user_roles_edit( $p_role_id, $p_user_id ){
		
		$v_query = 	"UPDATE 
						" . $this->get_db_table_prefix() . "user_role_assignment
					SET
						user_roles_id = '".\U::safe_sql_string( $p_role_id )."',
						_rec_modified_on = \"" . \U::safe_sql_string( date("Y-m-d H:i:s") ) . "\",
						_rec_modified_by = \"" . \U::safe_sql_string( \E::get_session( 'usr_id' ) ) . "\"
					WHERE
						user_id = '".\U::safe_sql_string( $p_user_id )."'
					";
		$v_result = $this->co_db_root->execute_query($v_query);
	}
	/**
	 * Function to update user group details
	 *
	 * @access public
	 * @return
	 */
	public function user_group_edit( $p_value ){
		$v_update_list = '';
		for($v_c=0; $v_c<$p_value['comp_count']; $v_c++){
			$v_update_list .= 'group_com_'.$p_value['acl'][$v_c]['name'].' = "' . \U::safe_sql_string( $p_value['acl'][$v_c]['value'] ) . '", ';
		}
		$v_query = 	"UPDATE 
					" . $this->get_db_table_prefix() . "acl_group 
					SET
						{$v_update_list}
						_rec_modified_on = \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
						_rec_modified_by = \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\"
					WHERE 
						group_id = \"" . \U::safe_sql_string( $p_value['id'] ) . "\"
					";
		$v_result = $this->co_db_root->execute_query($v_query);
		return $v_result;
	}
	/**
	 * Function to update user group label
	 *
	 * @access public
	 * @return
	 */
	public function user_group_lbl_edit( $p_value ){
		$v_lang_info = \E::get('obj_curr_module')->get_supported_lang();
		foreach($v_lang_info as $v_lang){
			$v_query = 	"UPDATE 
							" . $this->get_db_table_prefix() . "acl_group_lbl
						SET 
							kwd_value = \"" . \U::safe_sql_string( $p_value['group_name'][$v_lang] ) . "\",
							_rec_created_on = \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
							_rec_created_by = \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
							_rec_modified_on = \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
							_rec_modified_by = \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\"
						WHERE
							kwd_code = \"" . \U::safe_sql_string( $p_value['id'] ) . "\"
						AND
							kwd_lang = \"" . \U::safe_sql_string( $v_lang ) . "\"
						";
			$v_result = $this->co_db_root->execute_query($v_query);
		}
	}
	/**
	 * Function to soft delete user group
	 *
	 * @access public
	 * @return
	 */
	public function user_group_soft_del( $p_value ){
		$v_query = 	"UPDATE 
						" . $this->get_db_table_prefix() . "acl_group 
					SET
						_rec_deleted_on = \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
						_rec_deleted_by = \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
						_rec_status = \"DELETED\"
					WHERE 
						group_id = \"" . \U::safe_sql_string( $p_value['id'] ) . "\"
					";
		$v_result = $this->co_db_root->execute_query($v_query);
		if($v_result){
			return true;
		}else{
			return false;
		}
	}
	/**
	 * Function to hard delete user group
	 *
	 * @access public
	 * @return
	 */
	public function user_group_hard_del( $p_value ){
		$v_query = 	"DELETE FROM 
						" . $this->get_db_table_prefix() . "acl_group_lbl 
					WHERE 
						kwd_code = \"" . \U::safe_sql_string( $p_value['id'] ) . "\"
					";
		$v_result = $this->co_db_root->execute_query($v_query);
		$v_query = 	"DELETE FROM 
					" . $this->get_db_table_prefix() . "acl_group 
					WHERE 
						group_id = \"" . \U::safe_sql_string( $p_value['id'] ) . "\"
					";
		$v_result = $this->co_db_root->execute_query($v_query);
		if($v_result){
			return true;
		}else{
			return false;
		}
	}
	
 	/**
	 * Check duplicate group name
	 *
	 * @access public
	 * @return
	 */
	public function user_group_check_duplicate( $p_group_name, $p_group_id = NULL ){
		$v_cond = "";
		if( isset($p_group_id) && $p_group_id != "" ){
			$v_cond = " AND group_id != \"" . \U::safe_sql_string( $p_group_id ) . "\" ";
		}
		// QUERY
		$v_query = 	"SELECT 
						g.*
					FROM " . $this->get_db_table_prefix() . "acl_group g
					LEFT JOIN " . $this->get_db_table_prefix() . "acl_group_lbl l ON
					g.group_id=l.kwd_code
					WHERE g._rec_status = \"SHOW\" AND l._rec_status = \"SHOW\"
					AND l.kwd_value=\"" . \U::safe_sql_string( $p_group_name ) . "\"
					" . $v_cond;
		$v_result = $this->co_db_root->execute_query($v_query);
		return $v_result;
	}
	/**
	 * Get user role listing
	 *
	 * @access public
	 * @return
	 */
	public function user_group_roles(){
		$v_condition = "";
		$v_logged_in_user_role = \E::get_session( "logged_in_user_type");
		$v_login_type_user = "";
		$v_logged_in_user_role;
		if( $v_logged_in_user_role == 1 ) {
			$v_login_type_user = " AND role_type = 1 AND agency_id = '".\E::get_session("c_user_agency_id")."' ";
		}
		$v_query = "SELECT
					*
				FROM
					" . $this->get_db_table_prefix() . "user_roles
				WHERE
					_rec_status = \"SHOW\" 	
					".$v_condition."
					".$v_login_type_user."					
				";
		return $this->co_db_root->execute_query($v_query);
	}
	/**
	 * Get system info from code table
	 *
	 * @access public
	 * @return
	 */
	public function user_group_code_table_data(){	
		$v_query = "SELECT
					*
				FROM
					" . $this->get_db_table_prefix() . "code_table 
				WHERE
					_rec_status = \"SHOW\"
				AND
					for_module = \"system_info\"
				";
		return $this->co_db_root->execute_query($v_query);
	}
	/**
	 * GET AGENCY USRES ONLY
	 *
	 * @access public
	 * @return
	 */
	public function user_group_get_agency_users(){
		$v_col_name = "location";
		$v_location_condition = \E::get('obj_curr_module')->get_location_condition($v_col_name);
		$v_col_name = "agency";
		$v_agency_condition = \E::get('obj_curr_module')->get_agency_condition($v_col_name);
		$v_query = "SELECT
					*
				FROM
					" . $this->get_db_table_prefix() . "user 
				WHERE
					_rec_status = \"SHOW\" 	
					".$v_agency_condition."
					".$v_location_condition."
				";
		return $this->co_db_root->execute_query($v_query);
	}
}
?>