<div class="row container statistic_container col-md-12">
	<div class="col-md statistic_header gradient_shine">
		<span><?php echo \E::get('obj_curr_module_lang')->get('DASHBOARD_FEDERAL_ACCOUNT'); ?></span>
		<h1 id="countup_federal_account"></h1>
	</div>
	<div class="col-md statistic_header gradient_rainbow_blue">
		<span><?php echo \E::get('obj_curr_module_lang')->get('DASHBOARD_STATE_ACCOUNT'); ?></span>
		<h1 id="countup_state_account"></h1>
	</div>
	<div class="col-md statistic_header gradient_blooker20">
		<span><?php echo \E::get('obj_curr_module_lang')->get('DASHBOARD_PENDING_FEDERAL_BILLING'); ?></span>
		<h1 id="countup_federal_billing"></h1>
	</div>
	<div class="col-md statistic_header gradient_violet">
		<span><?php echo \E::get('obj_curr_module_lang')->get('DASHBOARD_PENDING_STATE_BILLING'); ?></span>
		<h1 id="countup_state_billing"></h1>
	</div>
	<div class="col-md statistic_header gradient_hazel">
		<span><?php echo \E::get('obj_curr_module_lang')->get('DASHBOARD_AP503_EXPORT'); ?></span>
		<h1 id="countup_federal_account_not_exported"></h1>
	</div>
</div>
<div class="row"><br/><br/></div>
<div class="row container statistic_container col-md-12">
	<div class="col-md statistic_chart">
		<canvas id="statistics_header_federal_account"></canvas>
	</div>
	<div class="col-md statistic_chart">
		<canvas id="statistics_header_state_account"></canvas>
	</div>
	<div class="col-md statistic_chart">
		<canvas id="statistics_header_ap504"></canvas>
	</div>
</div>
<br/><br/>
<script>
	let chartColors = [];
	chartColors.push('rgb(255, 99, 132)');
	chartColors.push('rgb(255, 159, 64)');
	chartColors.push('rgb(255, 205, 86)');
	chartColors.push('rgb(75, 192, 192)');
	chartColors.push('rgb(54, 162, 235)');
	chartColors.push('rgb(153, 102, 255)');
	chartColors.push('rgb(201, 203, 207)');
	chartColors.push('rgb(84, 80, 67)');
	chartColors.push('rgb(54, 34, 12)');
	chartColors.push('rgb(24, 66, 34)');
	chartColors.push('rgb(68, 82, 52)');
	chartColors.push('rgb(27, 55, 21)');
	chartColors.push('rgb(12, 36, 30)');
	chartColors.push('rgb(70, 10, 26)');
	chartColors.push('rgb(85, 25, 54)');
	chartColors.push('rgb(58, 62, 76)');
	chartColors.push('rgb(61, 6, 38)');
	chartColors.push('rgb(87, 89, 37)');
	chartColors.push('rgb(67, 62, 58)');
	chartColors.push('rgb(95, 67, 38)');
	chartColors.push('rgb(28, 35, 60)');
	chartColors.push('rgb(21, 60, 81)');
	chartColors.push('rgb(12, 37, 58)');
	chartColors.push('rgb(94, 67, 25)');
	chartColors.push('rgb(89, 80, 65)');
	var color = Chart.helpers.color;
	let v_backgroundColor = [];
	for (let i = 0; i < chartColors.length; i++) {
		v_backgroundColor.push(color(chartColors[i]).alpha(0.5).rgbString());
	}
	$(document).ready(function () {
		init_countup();
		var config = {
			data: {
				datasets: [{
					data: [
						<?php
						if (is_array($v_dashboard['federal'])) {
							foreach ($v_dashboard['federal'] as $v_value) {
								print \U::safe_sql_string($v_value['total_account']) . ', ';
							}
						}
						?>
					],
					backgroundColor: v_backgroundColor
				}],
				labels: [
					<?php
					if (is_array($v_dashboard['federal'])) {
						foreach ($v_dashboard['federal'] as $v_value) {
							print '"' . \U::safe_sql_string($v_value['site_code']) . '", ';
						}
					}
					?>
				]
			},
			options: {
				responsive: true,
				legend: {
					position: 'bottom',
				},
				title: {
					display: true,
					text: '<?php echo \E::get('obj_curr_module_lang')->get('DASHBOARD_FEDERAL_PUKAL_ACCOUNT_BY_SITE_CODE'); ?>',
					fontSize: 14,
				},
				scale: {
					ticks: {
						beginAtZero: true
					},
					reverse: false
				},
				animation: {
					animateRotate: false,
					animateScale: true
				}
			}
		};
		let chart_federal_account = Chart.PolarArea($("#statistics_header_federal_account")[0], config);
		var config = {
			data: {
				datasets: [{
					data: [
						<?php
						if (is_array($v_dashboard['state'])) {
							foreach ($v_dashboard['state'] as $v_value) {
								print \U::safe_sql_string($v_value['total_account']) . ', ';
							}
						}
						?>
					],
					backgroundColor: v_backgroundColor,
				}],
				labels: [
					<?php
					if (is_array($v_dashboard['state'])) {
						foreach ($v_dashboard['state'] as $v_value) {
							print '"' . \U::safe_sql_string($v_value['site_code']) . '", ';
						}
					}
					?>
				]
			},
			options: {
				responsive: true,
				legend: {
					position: 'bottom',
				},
				title: {
					display: true,
					text: '<?php echo \E::get('obj_curr_module_lang')->get('DASHBOARD_STATE_PUKAL_ACCOUNT_BY_SITE_CODE'); ?>',
					fontSize: 14,
				},
				scale: {
					ticks: {
						beginAtZero: true
					},
					reverse: false
				},
				animation: {
					animateRotate: false,
					animateScale: true
				}
			}
		};
		let chart_state_account = Chart.PolarArea($("#statistics_header_state_account")[0], config);
		var config = {
			type: 'pie',
			data: {
				datasets: [{
					data: [
						<?php
						print (isset($v_total_ap504['draft']) ? $v_total_ap504['draft'] : '0') . ', ';
						print (isset($v_total_ap504['processing']) ? $v_total_ap504['processing'] : '0');
						?>
					],
					backgroundColor: v_backgroundColor,
				}],
				labels: [
					'<?php echo \E::get('obj_curr_module_lang')->get('DASHBOARD_DRAFT'); ?>',
					'<?php echo \E::get('obj_curr_module_lang')->get('DASHBOARD_PROCESSING'); ?>'
				]
			},
			options: {
				responsive: true,
				legend: {
					position: 'bottom',
				},
				title: {
					display: true,
					text: '<?php echo \E::get('obj_curr_module_lang')->get('DASHBOARD_AP504_IN_PROGRESS'); ?>',
					fontSize: 14
				}
			}
		};
		let pie_chart = new Chart($("#statistics_header_ap504")[0], config);
	});
	function init_countup() {
		let countup_federal_account = new countUp.CountUp('countup_federal_account', <?php print isset($v_total_federal_account) ? \U::safe_display_string($v_total_federal_account) : 0; ?> );
		if (!countup_federal_account.error) {
			countup_federal_account.start();
		} else {
			console.error(countup_federal_account.error);
		}
		let countup_state_account = new countUp.CountUp('countup_state_account', <?php print isset($v_total_state_account) ? \U::safe_display_string($v_total_state_account) : 0; ?> );
		if (!countup_state_account.error) {
			countup_state_account.start();
		} else {
			console.error(countup_state_account.error);
		}
		let countup_federal_billing = new countUp.CountUp('countup_federal_billing', <?php print isset($v_total_federal_pending_billing) ? \U::safe_display_string($v_total_federal_pending_billing) : 0; ?> );
		if (!countup_federal_billing.error) {
			countup_federal_billing.start();
		} else {
			console.error(countup_federal_billing.error);
		}
		let countup_state_billing = new countUp.CountUp('countup_state_billing', <?php print isset($v_total_state_pending_billing) ? \U::safe_display_string($v_total_state_pending_billing) : 0; ?> );
		if (!countup_state_billing.error) {
			countup_state_billing.start();
		} else {
			console.error(countup_state_billing.error);
		}
		let countup_acount_not_exported = new countUp.CountUp('countup_federal_account_not_exported', <?php print isset($v_total_ap503) ? \U::safe_display_string($v_total_ap503) : ''; ?> );
		if (!countup_acount_not_exported.error) {
			countup_acount_not_exported.start();
		} else {
			console.error(countup_acount_not_exported.error);
		}
	}
</script>